VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "qrzInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' k0emt 's Access/VBA/VB QRZ Library
' Copyright (C) 2000 Bryan D Nehl

' This library is free software; you can redistribute it and/or
' modify it under the terms of the GNU Lesser General Public
' License as published by the Free Software Foundation; either
' version 2.1 of the License, or (at your option) any later version.

' This library is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
' Lesser General Public License for more details.

' You should have received a copy of the GNU Lesser General Public
' License along with this library; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

' Also add information on how to contact you by electronic and paper mail.

' The coordinator for this Library is:

'    Bryan Nehl
'    k0emt@dbbear.com
'    609  Carol Lane
'    California MO 65018

Option Explicit

' todo
' email address lookup
' gif lookup

' **** NOTE *****
' Access vs VB differences
' end vs application.quit
' no nz function
' don't change the hourglass

' qrz data structure ----------------------------------------------------
'     Callsign             0       AA7BQ
'     LastName           1       LLOYD
'     JR                     2       (reserved) *
'     FirstName          3       FRED L
'     MI                     4       (reserved) *
'     DateOfBirth       5       53340       // Dec 6, 1953
'     EffectiveDate    6       90009       // Jan 9, 1990
'     ExpirationDate   7       00009       // Jan 9, 2000
'     MailStreet         8       8215 E. Wood DR
'     MailCity             9       SCOTTSDALE
'     MailState          10      AZ
'     ZipCode            11      85260
'     LicenseClass     12      E       // (P = TechPlus)
'     PreviousCall      13      KJ6RK
'     PreviousClass    14      A

Private mqrz_strDBPath As String ' path to the data files and indices
                                                    ' sub directory callbk on cd-rom
                                                    ' doesn't include callbkc.dat portion, just path
Private mqrzIdxBytesPerKey As Long ' how many bytes does each key cover/span

' data members of the class
Private mCallSign As String       ' call sign in "normal" format
Private mqrzCallSign As String  ' call sign in QRZ format
Private mqrzDEFCAB As String   ' call sign in QRZ "defcab" format
Private mqrzIdx As Long           ' index used to start search, determined via qrzGetIndex
Private mqrzEMail As Boolean    ' email on cd - originally JR field - stored in a data file in an unknown format
Private mqrzGif As Boolean       ' gif on cd - originally MI field

Private mClass As String             ' license class
Private mLastName As String
Private mFirstName As String
Private mStreet As String
Private mCity As String
Private mState As String
Private mZip As String

Const CstrCallBook = "callbkc.dat"  ' name of the Call Book by Callsign data file

' used to set the path to the database location
Public Property Let DBPath(strDBPath As String)
    mqrz_strDBPath = strDBPath
End Property

Public Property Get DBPath() As String
    DBPath = mqrz_strDBPath
End Property

' when the user sets the call sign, look up all the info in QRZ
Public Property Let CallSign(strCall As String)
    mCallSign = UCase(strCall)
    qrzGetCallInfo mCallSign
End Property

Public Property Get CallSign() As String
    CallSign = mCallSign
End Property

Public Property Get qrzCallSign() As String
    qrzCallSign = mqrzCallSign
End Property

Public Property Get qrzDefCab() As String
    qrzDefCab = mqrzDEFCAB
End Property

Public Property Get hasEMail() As Boolean
    hasEMail = mqrzEMail
End Property

Public Property Get hasGif() As Boolean
    hasGif = mqrzGif
End Property

Public Property Get Class() As String
    Class = mClass
End Property

Public Property Get LastName() As String
    LastName = mLastName
End Property

Public Property Get FirstName() As String
    FirstName = mFirstName
End Property

Public Property Get ProperName() As String
    ProperName = mFirstName & " " & mLastName
End Property

Public Property Get Street() As String
    Street = mStreet
End Property

Public Property Get City() As String
    City = mCity
End Property

Public Property Get State() As String
    State = mState
End Property

Public Property Get Zip() As String
    Zip = mZip
End Property

' used to format call sign the way that it's stored in the QRZ
' call should be coming in already upper case
' modifies structure variables
Private Function qrzFormatCall(strCall As String) As String
Dim iLen As Long

    qrzFormatCall = strCall
    
    If IsNumeric(Mid(strCall, 3, 1)) Then
        ' 2 x something call
    Else
        ' 1 x something call
        qrzFormatCall = Left(strCall, 1) & " " & Mid(strCall, 2)
    End If
    
    ' pad with trailing spaces
    iLen = Len(qrzFormatCall)
    If iLen < 6 Then
        qrzFormatCall = qrzFormatCall & Space(6 - iLen)
    End If
    
    mqrzCallSign = qrzFormatCall
    mqrzDEFCAB = Right(mqrzCallSign, 3) & Mid(mqrzCallSign, 3, 1) & Left(mqrzCallSign, 2)
    
End Function

' returns a starting search index in the call sign database
' uses the qrz_strDBPath - looks into the callbkc.idx file
' takes a QRZ style call sign
' -1 couldn't open index file
' -2 eof before finding index entry
Private Function qrzGetIndex(strQRZCall As String) As Long
Dim idx As Long
Dim booFound As Boolean
Dim sSearchCall As String

Dim iFile As Long
Dim strData As String
Dim sDataName As String
Dim iBytesPerKey As Long
Dim iNumKeys As Long
Dim iKeyLen As Long
Dim sVersion As String
Dim sCall As String

    sSearchCall = iqrzDefCab(strQRZCall)
    qrzGetIndex = -1 ' at first to indicate index file not found
    
    ' if the db path name isn't set, we can't open it
    If IsNull(mqrz_strDBPath) Then Exit Function    ' *** NOTE: Access has NZ function
    If mqrz_strDBPath = "" Then Exit Function
    
    ' make sure index file exists/attempt to open *** dev ***
    
    ' read in the header info
    ' Index Header Block Definition (Version 2)
    ' (applies to all QRZ CDROMS from Version 2 onward)
    '      char  DataName[16];    /* Name of the data file            */
    '      char  BytesPerKey[8];  /* Data Bytes per Index Item        */
    '      char  NumKeys[8];      /* Number of items in this index    */
    '      char  KeyLen[8];       /* Length of each key item in bytes */
    '      char  Version[8];      /* Database Version ID              */
    
    iFile = FreeFile    ' get a free file handle #
    
    On Error GoTo Err_Handler
    Open mqrz_strDBPath & "\callbkc.idx" For Binary Access Read Shared As #iFile
    On Error GoTo 0
    
    sDataName = Input(16, iFile)
    iBytesPerKey = Val(Input(8, iFile))
    iNumKeys = Val(Input(8, iFile))
    iKeyLen = Val(Input(8, iFile))
    sVersion = Input(8, iFile)
    
    mqrzIdxBytesPerKey = iBytesPerKey ' set the module level variable with the size of the key "span"
    
    'Debug.Print "qgi: " & mqrz_strDBPath & "\callbkc.idx" & ":"; strData
    'Debug.Print "Data Name: " & sDataName
    'Debug.Print "DB version: " & sVersion
    'Debug.Print "Bytes Per Key: " & iBytesPerKey
    'Debug.Print "Num Keys: " & iNumKeys
    'Debug.Print "Key Len: " & iKeyLen

    ' loop until we have found an index value that is greater than our destination
    idx = 0: booFound = False
    
    While (Not booFound) And Not EOF(iFile)
        sCall = iqrzDefCab(Input(iKeyLen, iFile))
        ' Debug.Print sCall
        If StrComp(sSearchCall, sCall) < 0 Then booFound = True
        idx = idx + 1
    Wend
    
    Close #iFile
    
    ' return the appropriate value
    qrzGetIndex = (idx - 2) * iBytesPerKey
    mqrzIdx = qrzGetIndex
    
    Exit Function
Err_Handler:
    Select Case Err.Number
        Case 76
                MsgBox "The Call Book file was not found at the specified location." & vbCrLf & _
                        "Change your qrzInfo.DBPath setting", vbCritical, "k0emt's QRZ"
        Case Else
                MsgBox "Error #: " & Err.Number & vbCrLf & _
                        "Desc: " & Err.Description, _
                        vbCritical, "k0emt's QRZ"
    End Select
End Function

' given a call sign retrieve all the info about the call and store it in a data structure
Private Sub qrzGetCallInfo(strCall As String)
Dim idx As Long
Dim iFile As Long
Dim strData As String
Dim strQRZCall As String
Dim i As Long
Dim iBytesRead As Long
Dim iPosA As Long
Dim iPosB As Long
Dim booFound As Boolean

    booFound = False
    
    strQRZCall = qrzFormatCall(strCall)
    idx = qrzGetIndex(strQRZCall)
    
    Select Case idx
    Case -1 ' couldn't open index
                MsgBox "index file: " & mqrz_strDBPath & " not found", vbOKOnly, "qrzInfo Class"
                Exit Sub
    Case -2 ' eof was hit before reaching index
                MsgBox "entry: " & mqrzCallSign & " not found in index file", vbOKOnly, "qrzInfo Class"
                Exit Sub
    Case Else
                ' valid indices are greater than 0
                If idx < 0 Then
                    MsgBox "index file: " & mqrz_strDBPath & vbCrLf & _
                                "Error: " & idx, vbOKOnly, "qrzInfo Class"
                    Exit Sub
                End If
    End Select
    
    ' make sure index file exists/attempt to open
    iFile = FreeFile    ' get a free file handle #
    Open mqrz_strDBPath & "\" & CstrCallBook For Input As #iFile
    ' seek to the position specified by idx
    Seek iFile, idx
    
    ' Debug.Print "qGCI: " & mqrz_strDBPath & "\" & CstrCallBook & ":"
    i = 0: iBytesRead = 0
    
    Do While (Not (EOF(iFile)) And (iBytesRead < mqrzIdxBytesPerKey))
        ' if just use input, stops on commas
        ' get one character at a time
        strData = qrzGetLine(iFile)
        
        iBytesRead = iBytesRead + Len(strData) ' add up the number of bytes read
        
        If strQRZCall = Left(strData, 6) Then
            booFound = True
            'Debug.Print "Found at POS: " & Seek(iFile)
            
            ' strip the callsign & comma off
            strData = Right(strData, Len(strData) - 7)
            
            ' if the next field is a call sign and nothing comes after it
            ' then we have to look it up - this is a referral link
            iPosA = InStr(1, strData, ",") ' end point to name OR if not found referal call sign
            If iPosA = 0 Then
                ' use strdata
                mCallSign = UCase(strData)
                qrzGetCallInfo mCallSign
                Exit Sub
            End If
            
            mLastName = Mid(strData, 1, iPosA - 1)
            
            iPosB = InStr(iPosA + 1, strData, ",") ' end point to email on cd
            mqrzEMail = Not ((iPosB - iPosA) = 1) ' if it's only 1 different then no "." signifying has email
            
            iPosA = InStr(iPosB + 1, strData, ",") ' end point to firstname
            mFirstName = Mid(strData, iPosB + 1, (iPosA - iPosB) - 1)
            
            iPosB = InStr(iPosA + 1, strData, ",") ' end point to gif on cd
            mqrzGif = Not ((iPosB - iPosA) = 1) ' if it's only 1 different then no "." signifying has gif
            
            ' * skipping * birth, effective date, and expiration date
            '     DateOfBirth       5       53340       // Dec 6, 1953
            '     EffectiveDate    6       90009       // Jan 9, 1990
            '     ExpirationDate   7       00009       // Jan 9, 2000
            iPosA = InStr(iPosB + 1, strData, ",") ' end point to birth
            iPosB = InStr(iPosA + 1, strData, ",") ' end point to effective date
            iPosA = InStr(iPosB + 1, strData, ",") ' end point to expiration date
            
            iPosB = InStr(iPosA + 1, strData, ",") ' end point to street address
            mStreet = Mid(strData, iPosA + 1, (iPosB - iPosA) - 1)
            
            iPosA = InStr(iPosB + 1, strData, ",") ' end point to city
            mCity = Mid(strData, iPosB + 1, (iPosA - iPosB) - 1)
        
            iPosB = InStr(iPosA + 1, strData, ",") ' end point to state
            mState = Mid(strData, iPosA + 1, (iPosB - iPosA) - 1)
            
            iPosA = InStr(iPosB + 1, strData, ",") ' end point to zip
            mZip = Mid(strData, iPosB + 1, (iPosA - iPosB) - 1)
            
            iPosB = InStr(iPosA + 1, strData, ",") ' end point to license class
            mClass = Mid(strData, iPosA + 1, (iPosB - iPosA) - 1)
        
            Select Case mClass
            Case "N"
                            mClass = "Novice"
            Case "T"
                            mClass = "Technician"
            Case "P"
                            mClass = "Technician Plus"
            Case "G"
                            mClass = "General"
            Case "A"
                            mClass = "Advanced"
            Case "E"
                            mClass = "Extra"
            Case Else
                            mClass = mClass & " undefined *** ERROR ***"
            End Select
            
            ' * skipping * Previous Call & Previous Class
            Exit Do
        End If
    Loop
    
    Close #iFile
    'Debug.Print iBytesRead & " bytes read"
    'Debug.Print strData
        
    If booFound = False Then
        mCallSign = mCallSign & " not found in QRZ!"
        mqrzCallSign = "NOT FOUND"
    End If
    
End Sub

' read a QRZ "line"
' use the given file pointer
Private Function qrzGetLine(FileNum As Long) As String
Dim charData As String
Dim charT As String

    charData = ""
    While Not EOF(FileNum)
        charT = Input(1, FileNum)
        If (Asc(charT) <> 10) Then
            charData = charData & charT
        Else
            GoTo have_full_line
        End If
    Wend
    
have_full_line:
    qrzGetLine = charData
    
End Function

' used to format call sign the way that it's stored in the QRZ
' call should be coming in already upper case
Private Function iqrzDefCab(strCall As String) As String
Dim iLen As Long

    iqrzDefCab = strCall
    
    If IsNumeric(Mid(strCall, 3, 1)) Then
        ' 2 x something call
    Else
        ' 1 x something call
        iqrzDefCab = Left(strCall, 1) & " " & Mid(strCall, 2)
    End If
    
    ' pad with trailing spaces
    iLen = Len(iqrzDefCab)
    If iLen < 6 Then
        iqrzDefCab = iqrzDefCab & Space(6 - iLen)
    End If
    
    ' arrange into DefCab format
    iqrzDefCab = Right(iqrzDefCab, 3) & Mid(iqrzDefCab, 3, 1) & Left(iqrzDefCab, 2)
    
End Function


